AloftTag = { }
AloftTagMethods = { }
AloftTagVariables = { }

AloftTagMethods.name = function(aloftData, value) return aloftData.name end

AloftTagMethods.guild = function(aloftData, value) return aloftData.guild or "" end
AloftTagVariables.guild = "guild"

function AloftTag:ProcessTag(tag, offset, requiredVariablesTable, priorResult)

	local s,e = tag:find(":", offset)
	local quotedS,quotedE = tag:find("\"[^\"]*\"", offset)

	if quotedS and quotedS < (s or #tag) then
		if quotedE+1 == #tag then
			return string.format("(%s or %s)", priorResult, tag:sub(quotedS, quotedE))
		elseif quotedE+1 == s then
			return AloftTag:ProcessTag(tag, e+1, requiredVariablesTable, string.format("(%s or %s)", priorResult, tag:sub(quotedS, quotedE)))
		else
			requiredVariablesTable["ERROR"] = true
			return "\"\""
		end
	elseif s then
		local identifier = tag:sub(offset,s-1)
		if AloftTagMethods[identifier] then
			if AloftTagVariables[identifier] then
				requiredVariablesTable[AloftTagVariables[identifier]] = true
			end
			return AloftTag:ProcessTag(tag, e+1, requiredVariablesTable, string.format("AloftTagMethods.%s(aloftData, %s)", identifier, priorResult))
		else
			requiredVariablesTable["ERROR"] = true
			return "\"\""
		end
	else
		return string.format("AloftTagMethods.%s(aloftData, %s)", tag:sub(offset), priorResult)
	end
end


-- Returns a function to create the tag, and a table of required values
function AloftTag:CreateTagFunction(tag)
	-- TODO: Rewrite as a LL1 parser
	local functionString = "return function(aloftData) return "
	local requiredVariablesTable = { }

	offset = 1
	repeat
		local s, e = tag:find("%[[^[]+%]", offset)
		if offset ~= 1 then
			functionString = functionString..".."
		end
		if s then
			if s ~= offset then
				functionString = functionString.."\""..tag:sub(offset, s-1).."\".."
			end
			functionString = functionString.. AloftTag:ProcessTag(tag:sub(s+1, e-1), 1, requiredVariablesTable, "nil")
			offset = e+1
			if offset > #tag then
				offset = nil
			end
		else
			functionString = functionString.."\""..tag:sub(offset).."\""
			offset = nil
		end
	until offset == nil

	if requiredVariablesTable["ERROR"] then
		functionString = "return function() return \"Tag error\" end"
	else
		functionString = functionString.." end"
	end

	print(functionString)
	return loadstring(functionString)(), requiredVariablesTable
end
